<template>
    <div
        v-if="emailSubscribers && smsSubscribers"
        class="page-container"
    >
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/cartiio-onboarding-nvqcz2/reader'" />
        </div>
        <div class="search-select-container">
            <div v-if="selectedMenu !== 'Push'">
                <input
                    v-model="searchQuery"
                    type="text"
                    name="search"
                    placeholder="Search"
                    class="search-field form-control"
                    @input="search"
                >
            </div>
            <div class="selection-container">
                <div>
                    <label>
                        <b-select
                            v-model="selectedMenu"
                            class="form-control custom-select"
                            style="background-color: white"
                        >
                            <option
                                v-for="(menu, index) in selectMenus"
                                :key="index"
                                :value="menu.title"
                            >
                                {{ menu.title }}
                            </option>
                        </b-select>
                    </label>
                </div>
                <div>
                    <button
                        v-b-tooltip.hover.left="'Easily search, edit and delete your subscribers here. Filter them based on features and search directly using the search box'"
                        class="help-tooltip"
                    >
                        <i class="fa fa-question-circle-o" />
                    </button>
                </div>
            </div>
        </div>
        <EmailTable
            v-if="selectedMenu === 'Email'"
            :page-number="emailSubscribersPage"
            :email-subscribers="emailSubscribers"
            @getEmailSubscribers="getEmailSubscribers"
        />
        <PushTable
            v-if="selectedMenu === 'Push'"
            :page-number="pushSubscribersPage"
            :push-subscribers="pushSubscribers"
            @getPushSubscribers="getPushSubscribers"
        />
        <SmsTable
            v-if="selectedMenu === 'SMS'"
            :page-number="smsSubscribersPage"
            :sms-subscribers="smsSubscribers"
            @getSmsSubscribers="getSmsSubscribers"
        />
    </div>
</template>

<script>
import VideoButton from "@/components/header/VideoButton";
import EmailTable from "@/components/Home/email/EmailTable";
import SmsTable from "@/components/Home/sms/SmsTable";
import PushTable from "@/components/Home/push/PushTable";
import selectMenus from "@/data/selectMenus.json";
import subscribers from '@/mixins/subscribers/subscribers.service'

export default {
    name: "Subscribers",
    components: {SmsTable, EmailTable, VideoButton, PushTable},
    mixins: [subscribers],
    data: () => ({
        emailSubscribers: null,
        smsSubscribers: null,
        searchQuery: '',
        pushSubscribers: null,
        selectMenus: selectMenus,
        selectedMenu: 'Email',
        emailSubscribersPage: {
            number: 1
        },
        pushSubscribersPage: {
            number: 1
        },
        smsSubscribersPage: {
            number: 1
        }
    }),
    mounted() {
        this.getEmailSubscribers()
        this.getSmsSubscribers()
        this.getPushSubscribers()
    },
    methods: {
        async getEmailSubscribers(pageNumber = 1) {
            this.emailSubscribersPage.number = pageNumber
            const response = await this.email(pageNumber, this.searchQuery)
            try {
                this.emailSubscribers = response.data
            } catch (error) {
                console.log(error)
            }
        },
        async getPushSubscribers(pageNumber = 1) {
            this.pushSubscribersPage.number = pageNumber
            const response = await this.push(pageNumber, this.searchQuery)
            try {
                this.pushSubscribers = response.data
            } catch (error) {
                console.log(error)
            }
        },
        async getSmsSubscribers(pageNumber = 1) {
            this.smsSubscribersPage.number = pageNumber
            const response = await this.sms(pageNumber, this.searchQuery)
            try {
                this.smsSubscribers = response.data
            } catch (error) {
                console.log(error)
            }
        },
        search() {
            switch(this.selectedMenu) {
                case 'Email': {
                    this.getEmailSubscribers()
                    break
                }
                case 'SMS': {
                    this.getSmsSubscribers()
                    break
                }
            }
        }
    }
}
</script>

<style scoped lang="scss">
::v-deep .subscribes__table {
    max-width: 1240px;
    width: 100%;
    .table-hover {
        min-width: auto;
        thead th {
            white-space: nowrap;
        }
    }
}
.my-input {
    width: 280px;
}

.selection-container {
    display: flex;
    align-items: center;
    margin-left: auto;

    label {
        margin-bottom: 0;
    }

    @media screen and (max-width: 926px) {
        margin-top: 20px;
    }
}

.custom-select {
    margin-right: 10px;
    width: 200px;

    &:hover {
        background-color: #ECF3FE !important;
        cursor: pointer;
    }
}

.search-select-container {
    margin-top: 30px;
    margin-bottom: 30px;
    display: flex;
    justify-content: space-between;
    @media screen and (max-width: 926px) {
        flex-direction: column;
    }
}
.search-field {
    min-width: 225px;
}
</style>
